Magellan Linux

Diff of /trunk/mage/usr/lib/mage/smage2.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 192 by niro, Fri Aug 19 03:43:56 2005 UTC revision 2805 by niro, Tue Sep 2 13:53:08 2014 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.23 2005-08-19 03:43:56 niro Exp $  
8    
 #01.10.2004  
 # added ccache support  
 # added distcc support  
9    
10  ## setup ##  # set default user mage.rc
11  PKGSUFFIX="mpk"  : ${MAGERC="/etc/mage.rc"}
 SMAGENAME="$1"  
 SMAGESUFFIX="smage2"  
 #SOURCEDIR="/bootstrap/sources"  
 #SMAGESCRIPTSDIR="/bootstrap/smage2-install-scripts"  
 #SMAGE2RSYNC="rsync://192.168.0.2/smage2-scripts"  
 MLIBDIR=/usr/lib/mage  
 SMAGEVERSION="$( < ${MLIBDIR}/version)"  
12    
13  # export default C locale  # export default C locale
14  export LC_ALL=C  export LC_ALL=C
15    
16  source /etc/mage.rc  source /etc/mage.rc.global
17    source ${MAGERC}
18  showversion() {  source ${MLIBDIR}/mage4.functions.sh
19   echo -en "Magellan Source Install v${SMAGEVERSION} "  source ${MLIBDIR}/smage2.functions.sh
  echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  
 }  
   
 die() {  
  xtitleclean  
  echo "SMAGE failed: $@"  
  exit 1  
 }  
   
 xtitle() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
   
 xtitleclean() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2() {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync \  
  --recursive \  
  --links \  
  --perms \  
  --times \  
  --devices \  
  --timeout=600 \  
  --verbose \  
  --compress \  
  --progress \  
  --stats \  
  --delete \  
  --delete-after \  
  ${i} ${SMAGESCRIPTSDIR}  
   
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
   
  done  
   
  #clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # $1 filename  
 get_db_md5_sum() {  
  local DB_FILE  
  local MD5_FILE  
  local i  
   
  DB_ENTRY="$(basename $1)"  
  MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"  
   
  i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"  
   
  echo "${i}"  
 }  
   
 download_sources() {  
   
  [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0  
   
  local EOA=${#SRC_URI[*]}  
  local my_SRC_URI  
  local my_SRC_URI_DEST  
  local my_SRC_URI_MIRROR  
  local my_SOURCEDIR  
  local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"  
  local FETCHING  
  local i mirror  
   
   
  #install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
   
  # check if FETCHING is needed  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )  
  if [[ $? == 0 ]]  
  then  
  # md5's ok, not fetching needed  
  FETCHING=false  
  else  
  FETCHING=true  
  fi  
   
  for ((i=0; i < EOA; i++))  
  do  
  # url to file  
  my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"  
   
  # subdir in sources dir; the my_SRCI_URI file goes to there  
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
   
  # if an mirrored file than replace first the mirror uri  
  if [ -n "$(echo ${my_SRC_URI} | grep 'mirror://')" ]  
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
   
  #echo "DEBUG: ${MY_SRC_URI}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI_MIRROR}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  #echo "DEBUG: ${SRC_URI[${i}]}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI}"  
 # only needed to run through a list of mirrors  
 # if [ "$?" == "0" ]  
 # then  
 # break  
 # else  
 # continue  
 # fi  
  fi  
  fi  
   
  # unset them to be shure  
  unset my_SRC_URI  
  unset my_SRC_URI_DEST  
  unset my_SRC_URI_MIRROR  
  unset my_SOURCEDIR  
  done  
   
  # recheck md5 sums  
  echo  
  echo ">== Checking MD5 sums:"  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"  
  echo  
   
  # not needed anymore  
  unset SRC_URI  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_prepare() {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_compile() {  
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_install() {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
 }  
   
 mconfigure() {  
  if [ -x ./configure ]  
  then  
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
   
 minstall() {  
  if [ -f ./[mM]akefile -o -f ./GNUmakefile ] ; then  
  make prefix=${BINDIR}/usr \  
  datadir=${BINDIR}/usr/share \  
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
   
 mmake() {  
  make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  
 }  
   
 munpack() {  
  local SRCFILE  
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [ -z "$2" ]  
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  tbz2)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
  esac  
 }  
   
 mpatch() {  
  local PATCHOPTS  
  local PATCHFILE  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
   
 minstalldocs() {  
  local docfiles  
   
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for i in ${docfiles}  
  do  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  done  
 }  
   
 mstriplibs() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 mstripbins() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 sminclude() {  
  local i  
   
  if [[ -n "$@" ]]  
  then  
  for i in $@  
  do  
  echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"  
  source ${SMAGESCRIPTSDIR}/include/${i}.sminc  
  done  
  echo  
  fi  
 }  
   
 setup_distcc_environment(){  
  if [ -x /usr/bin/distcc ]  
  then  
  echo "Using DistCC for compilation ..."  
  export PATH=/usr/lib/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  #export distcc as compiler  
 # export CC="distcc"  
 # export CXX=distcc  
   
  export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  
   
   
  #ccache + distcc together  
  if [ "${SMAGE_USE_CCACHE}" == "true" ]  
  then  
  if [ -x /usr/bin/ccache ]  
  then  
  echo "Preparing DistCC to work together with CCache ..."  
  #export CCACHE_PREFIX="distcc" || die "distcc: could not set ccach_prefix"  
 # export CC="ccache distcc"  
 # export CXX="ccache distcc"  
  fi  
  fi  
   
  #creating distcc tempdir  
  install -o distcc -g daemon -d ${DISTCC_DIR}  
  chmod 1777 ${DISTCC_DIR}  
  fi  
 }  
   
 setup_ccache_environment(){  
  if [ -x /usr/bin/ccache ]  
  then  
  echo "Using CCache for compilation ..."  
  export PATH=/usr/lib/ccache/bin:${PATH} || die "ccache: could not export new $PATH"  
  #unset CC CXX  
  fi  
 }  
   
 # build_mage_script(): helper functions for regen_mage_tree()  
 # generates an mage file with given information in smage file  
 # needs at least:  
 #   PNAME                 name of pkg  
 #   PVER                  version  
 #   PBUILD                revision  
 #   PCATEGORIE            categorie of the pkg  
 #   STATE                 state of pkg stable|unstable|old  
 #   DESCRIPTION           va short description (opt)  
 #   HOMEPAGE              homepage (opt)  
 #   DEPEND                runtime dependencies (opt)  
 #   SDEPEND               add. needed deps to build the pkg (opt)  
 #   PROVIDE               provides a virtual (opt)  
 #  
 # special tags:  
 #   PKGTYPE               type of pkg  
 #   INHERITS              which functions get included  
 #   SPECIAL_FUNCTIONS     special functions wich should also be added  
 #                         warning: they get killed before the build starts !  
 #  
 #   MAGE_TREE_DEST        target destination of the generated tree  
 #   REGEN_MAGE_TREE       set to 'true' to enable this  
 build_mage_script()  
 {  
  local magefile  
  local dest  
  local suffix  
  local sym  
  local depname  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
   
  # determinate which suffix this mage file should get, if any  
  suffix="$1"  
   
  # name of magefile  
  magefile="${PNAME}${suffix}-${PVER}-${PBUILD}.mage"  
   
  # destination to magefile  
  dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${suffix}/${magefile}"  
   
  # show what we are doing  
  echo "Generating Mage file:"  
  echo "  ${dest}"  
   
  install -d "$(dirname ${dest})"  
  # now build the mage file  
  > ${dest}  
   
  # header  
  echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.23 2005-08-19 03:43:56 niro Exp $' >> ${dest}  
  echo  >> ${dest}  
   
  # pgkname and state  
  echo "PKGNAME=\"${PNAME}${suffix}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}  
  echo "STATE=\"${STATE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # description and homepage  
  echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}  
  echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # special tags  
  echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}  
  if [ -n "${INHERITS}" ]  
  then  
  echo -n "minclude"  >> ${dest}  
  local i  
  for i in ${INHERITS}  
  do  
  echo -n " ${i}"  >> ${dest}  
  done  
  echo  >> ${dest}  
  fi  
  echo >> ${dest}  
20    
21   # deps and provides  # export default path
22   echo "DEPEND=\"${DEPEND}\"" >> ${dest}  export PATH="${PATH}:${MLIBDIR}"
  echo "SDEPEND=\"${SDEPEND}\"" >> ${dest}  
  echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}  
  echo >> ${dest}  
23    
24   # add special functions  ## setup ##
25   if [ -n "${SPECIAL_FUNCTIONS}" ]  SMAGENAME="$1"
26   then  SMAGEVERSION="$(< ${MLIBDIR}/version)"
  local i  
  for i in ${SPECIAL_FUNCTIONS}  
  do  
  # add to mage (quotes needed !)  
  typeset -f "${i}" >> ${dest}  
  # unset to be safe (quotes needed !)  
  #unset "${i}" <-- later to get every target built  
  done  
  fi  
   
  # pre|post-install|removes  
  typeset -f preinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f postinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f preremove >> ${dest}  
  echo  >> ${dest}  
  typeset -f postremove >> ${dest}  
  echo  >> ${dest}  
 }  
   
 regen_mage_tree()  
 {  
  local i  
   
  # build them only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  # build for each target an mage file  
  for i in ${MAGE_TARGETS}  
  do  
  echo  
  build_mage_script "${i}"  
  echo  
  done  
  fi  
27    
28   # now unset all uneeded vars to be safe  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
29   # unset PKGNAME <-- don't do that; smage needs this var  if [[ -n ${MROOT} ]]
30   # unset to be safe (quotes needed !)  then
31   for i in ${SPECIAL_FUNCTIONS}   export PKGDIR=${MROOT}/${PKGDIR}
32   do   export BUILDDIR=${MROOT}/${BUILDDIR}
33   unset "${i}"   export BINDIR=${MROOT}/${BINDIR}
34   done  fi
  unset SPECIAL_FUNCTIONS  
  unset STATE  
  unset DESCRIPTION  
  unset HOMEPAGE  
  unset PKGTYPE  
  unset INHERITS  
  unset DEPEND  
  unset SDEPEND  
  unset PROVIDE  
  unset preinstall  
  unset postinstall  
  unset preremove  
  unset postremove  
 }  
35    
36  # print out our version  # print out our version
37  showversion  showversion
38  echo  echo
39    
40  if [ -z "$1" ]  if [[ -z ${SMAGENAME} ]]
41  then  then
42   echo "No .smage2 file given. Exiting."   echo "No .smage2 file given. Exiting."
43   echo   echo
44   exit 1   exit 1
45  fi  fi
46    
47    # load supported mage features
48    load_mage_features
49    
50  # updating smage2-scripts  # updating smage2-scripts
51  if [ "$1" == "update" ]  if [[ $1 = update ]]
52  then  then
53   if [ ! -d ${SOURCEDIR} ]   if [ ! -d ${SOURCEDIR} ]
54   then   then
# Line 575  then Line 59  then
59  fi  fi
60    
61  # creates md5sums for smages to given dir  # creates md5sums for smages to given dir
62  if [ "$1" == "calcmd5" ]  if [[ $1 = calcmd5 ]]
63  then  then
64   if [ $# -ge 3 ]   if [ $# -ge 2 ]
65   then   then
66   SMAGENAME="$2"   SMAGENAME="$2"
67   MD5DIR="$3"   MD5DIR="$3"
68   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
69    
70     smagesource ${SMAGENAME} || die "download source failed"
71    
72   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
73   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 627  then Line 113  then
113   unset my_SRC_URI_MIRROR   unset my_SRC_URI_MIRROR
114   unset my_SOURCEDIR   unset my_SOURCEDIR
115   done   done
116    
117   echo   echo
118   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."
119   echo   echo
120   else   else
121   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
122   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
123   echo   echo
124   echo   echo
125   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
126   echo   echo
127   exit 1   exit 1
128   fi   fi
129    
130   exit 0   exit 0
131  fi  fi
132    
# Line 655  then Line 141  then
141   # get smage   # get smage
142   SMAGENAME="$2"   SMAGENAME="$2"
143   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
144   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
145    
146   download_sources   download_sources
147   exit 0   exit 0
148  fi  fi
149    
150  if [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ]  # regen-mage-tree
151    if [ "$1" == "only-regen-tree" -a -n "$2" ]
152  then  then
153   die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."   # set correct SMAGENAME
154  fi   SMAGENAME="$2"
155     MD5DIR="$(dirname ${SMAGENAME})/md5"
156     smagesource ${SMAGENAME} || die "regen: smage2 not found"
157    
158  if [ -z "`basename ${SMAGENAME}|grep .${SMAGESUFFIX}`" ]   regen_mage_tree
 then  
  die "File '`basename ${SMAGENAME}`' is not a sMage v${SMAGEVERSION} file. Aborting."  
 fi  
159    
160  if [ -z "${SOURCEDIR}" ]   # build several subpackages
161  then   if [[ -n ${SPLIT_PACKAGES} ]]
162   die "\$SOURCEDIR not found. Please setup your mage.rc correctly."   then
163  fi   split_save_variables
164     for subpackage in ${SPLIT_PACKAGES}
165     do
166     # get the right variables for the split
167     export PNAME="${subpackage}"
168     split_info_${subpackage}
169     # fix PCATEGORIE -> PCAT
170     if [[ ! -z ${PCATEGORIE} ]]
171     then
172     PCAT="${PCATEGORIE}"
173     unset PCATEGORIE
174     fi
175     # build md5sum for existing packages
176     generate_package_md5sum \
177     --pcat "${PCAT}" \
178     --pname "${PNAME}" \
179     --pver "${PVER}" \
180     --pbuild "${PBUILD}" \
181     --parch "${ARCH}"
182     # restore smage environment
183     split_restore_variables
184     done
185     # unset all saved smage variables
186     split_unset_variables
187    
188  if [ -z "${SMAGESCRIPTSDIR}" ]   else
189  then   # build md5sum for existing packages
190   die "\$SMAGESCRIPTSDIR not found. Please setup your mage.rc correctly."   generate_package_md5sum \
191  fi   --pcat "${PCAT}" \
192     --pname "${PNAME}" \
193     --pver "${PVER}" \
194     --pbuild "${PBUILD}" \
195     --parch "${ARCH}"
196     fi
197    
198  if [ -z "${SMAGE2RSYNC}" ]   exit 0
 then  
  echo "\$SMAGE2RSYNC not found. Please setup your mage.rc correctly."  
  exit 1  
199  fi  fi
200    
201  if [ -z "${BINDIR}" ]  if [ "$1" == "--create-src-tarball" -a -n "$2" ]
202  then  then
203   die "no BINDIR variable found in /etc/mage.rc"   # set correct SMAGENAME
204  fi   SMAGENAME="$2"
205     MD5DIR="$(dirname ${SMAGENAME})/md5"
206    
207  if [ -z "${CHOST}" ]   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
208  then  
209   die "no CHOST variable found in /etc/mage.rc"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
210    
211     if [[ -d ${SOURCEDIR}/${PNAME} ]]
212     then
213     echo -e "${COLGREEN}Deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
214     rm -rf ${SOURCEDIR}/${PKGNAME}
215     fi
216    
217     download_sources
218     source_pkg_build ${SMAGENAME}
219     exit 0
220  fi  fi
221    
222  if [ -z "${CFLAGS}" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
223  then  then
224   die "no CFLAGS variable found in /etc/mage.rc"   SRCPKGTARBALL="${2}"
225     msetfeature "srcpkgtarball"
226    
227     # abort if given file is not a source pkg
228     [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
229    
230     # set correct SMAGENAME; use the one that the src_pkg provide
231     # /path/to/SOURCEDIR/PNAME/SMAGENAME
232     SMAGENAME="${SOURCEDIR}/$(basename ${SRCPKGTARBALL%-*-*})/$(basename ${SRCPKGTARBALL} .${SRCPKGSUFFIX}).${SMAGESUFFIX}"
233    
234     echo -e "${COLGREEN}Using src-tarball ${COLBLUE}${SRCPKGTARBALL}${COLGREEN} ...${COLDEFAULT}"
235    
236     [[ ! -d ${SOURCEDIR} ]] && install -d ${SOURCEDIR}
237    
238     # unpack srctarball
239     [[ ! -f ${SRCPKGTARBALL} ]] && die "Error: ${SRCPKGTARBALL} does not exist. Aborting."
240    
241     tar xvjf ${SRCPKGTARBALL} -C ${SOURCEDIR} || die  "Error unpackung src-tarball ${SRCPKGTARBALL}"
242    
243     [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
244  fi  fi
245    
246  if [ -z "${CXXFLAGS}" ]  if [ "$1" == "--resume" -a -n "$2" ]
247  then  then
248   die "no CXXFLAGS variable found in /etc/mage.rc"   msetfeature "resume"
249     SMAGENAME="$2"
250  fi  fi
251    
252    [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."
253    [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
254     die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
255    [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
256    [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your ${MAGERC} correctly."
257    [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your ${MAGERC} correctly."
258    [ -z "${BINDIR}" ] && die "no BINDIR variable found in ${MAGERC}"
259    [ -z "${CHOST}" ] && die "no CHOST variable found in ${MAGERC}"
260    [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
261    [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
262    
263  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
264  PKGNAME="${PNAME}-${PVER}-${CHOST%%-*}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
265  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
266    SMAGE_LOG_CMD="tee -a ${SMAGELOGDIR}/${PKGNAME}.log"
267    
268  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
269  echo "Compiling ${PKGNAME}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
270    
271  # auto regen mage tree if requested  if mqueryfeature "srcpkgbuild"
272  regen_mage_tree  then
273     if [[ -d ${SOURCEDIR}/${PNAME} ]]
274     then
275     echo -e "${COLBLUE}===${COLGREEN} deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
276     rm -rf ${SOURCEDIR}/${PNAME}
277     fi
278    fi
279    
280  # download sources  # download sources
281  download_sources  mqueryfeature "srcpkgtarball" || download_sources
282    
283  # fixes some issues with these functions  # fixes some issues with these functions
284    export -f pkg_setup || die "pkg_setup export failed"
285  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
286  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
287    export -f src_check || die "src_check export failed"
288  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
289    
290  # fixes some compile issues  # fixes some compile issues
291  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
292  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
293  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
294    then
295     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
296    else
297     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
298    fi
299    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
300  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
301  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
302    
   
303  # setup distcc  # setup distcc
304  # distcc mus be setup *before* ccache, as ccache need to be before distcc in path  # setup for distcc goes *before* ccache, so ccache comes before distcc in path
305  if [ "${SMAGE_USE_DISTCC}" == "true" ]  mqueryfeature "distcc" && setup_distcc_environment
306  then  
307   setup_distcc_environment  # setup icecc
308  fi  # setup for icecc goes *before* ccache, so ccache comes before icecc in path
309    mqueryfeature "icecc" && setup_icecc_environment
310    
311  # setup ccache  # setup ccache
312  if [ "${SMAGE_USE_CCACHE}" == "true" ]  mqueryfeature "ccache" && setup_ccache_environment
313    
314    if mqueryfeature "resume"
315  then  then
316   setup_ccache_environment   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
 fi  
317    
318     # setup build logging
319     [[ ! -d ${SMAGELOGDIR} ]] && install -d ${SMAGELOGDIR}
320     if [[ -f ${SMAGELOGDIR}/${PKGNAME}.log.bz2 ]]
321     then
322     bunzip2 -f ${SMAGELOGDIR}/${PKGNAME}.log.bz2
323     fi
324     echo -e "### Resume started on $(date) ###\n" >> ${SMAGELOGDIR}/${PKGNAME}.log
325    
326  # small sleep to show our settings  else
327  sleep 1   # clean up builddir if a previously one exist
328     if [ -d ${BUILDDIR} ]
329     then
330     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
331     fi
332     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
333    
334  #debug   # clean up srcdir if a previously unpacked one exist
335  #echo "CC=${CC}"   if [ -d ${SRCDIR} ]
336  #echo "CXX=${CXX}"   then
337  #echo "DISTCC_DIR=${DISTCC_DIR}"   rm -rf ${SRCDIR}
338  #echo "PATH: ${PATH}"   fi
 #echo "--------------------------------------"  
 #env  
 #echo "--------------------------------------"  
 #read  
 #debug end  
339    
340  # cleans up build if a previously one exists   # clean up bindir if a previous build exist or create a new one
341  if [ -d ${BUILDDIR} ]   if [ -d ${BINDIR} ]
342  then   then
343   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   rm -rf ${BINDIR}
344     fi
345     install -d ${BINDIR} || die "couldn't create \$BINDIR."
346    
347     # clean up package temp dir if a previous build exist
348     if [ -d ${BUILDDIR}/${PKGNAME} ]
349     then
350     rm -rf ${BUILDDIR}/${PKGNAME}
351     fi
352    
353     # clean up stamps dir
354     if [ -d ${BUILDDIR}/.stamps ]
355     then
356     rm -rf ${BUILDDIR}/.stamps
357     fi
358    
359     # setup build logging
360     [[ ! -d ${SMAGELOGDIR} ]] && install -d ${SMAGELOGDIR}
361     echo -e "### Build started on $(date) ###\n" > ${SMAGELOGDIR}/${PKGNAME}.log
362  fi  fi
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
363    
364  # cleans up srcdir if a previously unpacked one exists  if [[ ${PKGTYPE} = virtual ]]
 if [ -d ${SRCDIR} ]  
365  then  then
366   rm -rf ${SRCDIR}   echo "virtual package detected; nothing will be build ..."
367     # automatically set !pkgbuild here too
368     msetfeature "!pkgbuild"
369    else
370     ( run_resume pkg_setup || pkg_setup ) | ${SMAGE_LOG_CMD}
371     die_pipestatus 0 "pkg_setup failed"
372     resume_stamp pkg_setup
373     step_by_step pkg_setup
374    
375     ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
376     die_pipestatus 0 "src_prepare failed"
377     resume_stamp src_prepare
378     step_by_step src_prepare
379    
380     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
381     die_pipestatus 0 "src_compile failed"
382     resume_stamp src_compile
383     step_by_step src_compile
384    
385     # only run checks if requested
386     if mqueryfeature "!check"
387     then
388     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
389     else
390     ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
391     die_pipestatus 0 "src_check failed"
392     resume_stamp src_check
393     fi
394     step_by_step src_check
395    
396     # build several subpackages
397     if [[ -n ${SPLIT_PACKAGES} ]]
398     then
399     # save bindir & pname
400     split_save_variables
401     export SAVED_BINDIR="${BINDIR}"
402     for subpackage in ${SPLIT_PACKAGES}
403     do
404     split_info_${subpackage}
405     if [[ ${PKGTYPE} = virtual ]]
406     then
407     echo
408     echo -en "${COLBLUE}*** ${COLDEFAULT}"
409     echo -en "Virtual package detected"
410     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
411     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
412    
413     echo "virtual package detected; nothing will be build ..."
414     # automatically set !pkgbuild here too
415     msetfeature "!pkgbuild"
416     else
417     if typeset -f src_install_${subpackage} > /dev/null
418     then
419     # export subpackage bindir
420     export BINDIR="${SAVED_BINDIR}_${subpackage}"
421     # export PNAME, several internal function and include
422     # rely on this variable
423     export PNAME="${subpackage}"
424    
425     echo
426     echo -en "${COLBLUE}*** ${COLDEFAULT}"
427     echo -en "Running ${COLGREEN}split src_install()${COLDEFAULT}"
428     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
429     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
430    
431     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
432     die_pipestatus 0 "src_install_${subpackage} failed"
433     resume_stamp src_install_${subpackage}
434     step_by_step src_install_${subpackage}
435     fi
436     fi
437     # restore smage environment
438     split_restore_variables
439     done
440     # unset all saved smage variables
441     split_unset_variables
442     else
443     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
444     die_pipestatus 0 "src_install failed"
445     resume_stamp src_install
446     step_by_step src_install
447     fi
448  fi  fi
449    
450  # cleans up bindir if a previous build exists or creates a new one  # echo for sake of good-looking
451  if [ -d ${BINDIR} ]  echo
452    
453    if mqueryfeature "!compressdoc"
454  then  then
455   rm -rf ${BINDIR}   echo -e "!compressdoc detected; documentation will not be compressed ..."
456    elif mqueryfeature "!pkgbuild"
457    then
458     echo "!pkgbuild detected; skipping documentation compression..."
459    else
460     # compressing doc, info & man files
461     if [[ -n ${SPLIT_PACKAGES} ]]
462     then
463     # save smage environment
464     split_save_variables
465     for subpackage in ${SPLIT_PACKAGES}
466     do
467     # honor split_info
468     split_info_${subpackage}
469     if [[ ${PKGTYPE} = virtual ]]
470     then
471     # automatically set !pkgbuild here too
472     msetfeature "!pkgbuild"
473     fi
474    
475     if mqueryfeature "!compressdoc"
476     then
477     echo -e "!compressdoc detected; documentation of '${subpackage}' will not be compressed ..."
478     elif mqueryfeature "!pkgbuild"
479     then
480     echo "!pkgbuild detected; skipping documentation compression for '${subpackage}' ..."
481     else
482     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
483     resume_stamp post-mcompressdoc_${subpackage}
484     fi
485     # restore smage environment
486     split_restore_variables
487     done
488     # unset saved variables
489     split_unset_variables
490     else
491     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
492     resume_stamp post-mcompressdoc
493     fi
494  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
495    
496  # cleans up package temp dir if a previous build exists  if mqueryfeature "!libtool"
 if [ -d ${BUILDDIR}/${PKGNAME} ]  
497  then  then
498   rm -rf ${BUILDDIR}/${PKGNAME}   if mqueryfeature "!pkgbuild"
499     then
500     echo "!pkgbuild detected; skipping libtool archive stripping ..."
501     else
502     if [[ -n ${SPLIT_PACKAGES} ]]
503     then
504     # save smage environment
505     split_save_variables
506     for subpackage in ${SPLIT_PACKAGES}
507     do
508     # honor split_info
509     split_info_${subpackage}
510     if [[ ${PKGTYPE} = virtual ]]
511     then
512     # automatically set !pkgbuild here too
513     msetfeature "!pkgbuild"
514     fi
515    
516     if mqueryfeature "!libtool"
517     then
518     if mqueryfeature "!pkgbuild"
519     then
520     echo "!pkgbuild detected; skipping libtool archive stripping for '${subpackage}'..."
521     else
522     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
523     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
524     resume_stamp post-mstriplibtoolarchive_${subpackage}
525     fi
526     fi
527    
528     # restore smage environment
529     split_restore_variables
530     done
531     # unset saved variables
532     split_unset_variables
533     else
534     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
535     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
536     resume_stamp post-mstriplibtoolarchive
537     fi
538     fi
539  fi  fi
540    
541  # cleans up timestamp if one exists  if mqueryfeature "purge"
 if [ -f /var/tmp/timestamp ]  
542  then  then
543   mage rmstamp   if mqueryfeature "!pkgbuild"
544  fi   then
545     echo "!pkgbuild detected; skipping file purgation ..."
546     else
547     if [[ -n ${SPLIT_PACKAGES} ]]
548     then
549     # save smage environment
550     split_save_variables
551     for subpackage in ${SPLIT_PACKAGES}
552     do
553     # honor split_info
554     split_info_${subpackage}
555     if [[ ${PKGTYPE} = virtual ]]
556     then
557     # automatically set !pkgbuild here too
558     msetfeature "!pkgbuild"
559     fi
560    
561  src_prepare || die "src_prepare failed"   if mqueryfeature "purge"
562  src_compile || die "src_compile failed"   then
563  src_install || die "src_install failed"   if mqueryfeature "!pkgbuild"
564     then
565     echo "!pkgbuild detected; skipping file purgation for '${subpackage}' ..."
566     else
567     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
568     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
569     resume_stamp post-mpurgetargets_${subpackage}
570     fi
571     fi
572    
573     # restore smage environment
574     split_restore_variables
575     done
576     # unset saved variables
577     split_unset_variables
578     else
579     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
580     run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
581     resume_stamp post-mpurgetargets
582     fi
583     fi
584    fi
585    
586  # compressing doc, info & man files  # stripping all bins and libs
587  echo -e "Compressing man-pages ..."  if mqueryfeature "!strip"
 if [ -d ${BUILDDIR}/builded/usr/share/man ]  
588  then  then
589   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   echo -e "!strip detected; package will not be stripped ..."
590    elif mqueryfeature "!pkgbuild"
591    then
592     echo "!pkgbuild detected; skipping stripping of the package ..."
593    else
594     if [[ -n ${SPLIT_PACKAGES} ]]
595     then
596     # save smage environment
597     split_save_variables
598     for subpackage in ${SPLIT_PACKAGES}
599     do
600     # honor split_info
601     split_info_${subpackage}
602     if [[ ${PKGTYPE} = virtual ]]
603     then
604     # automatically set !pkgbuild here too
605     msetfeature "!pkgbuild"
606     fi
607    
608     if mqueryfeature "!strip"
609     then
610     echo -e "!strip detected; package '${subpackage}' will not be stripped ..."
611     elif mqueryfeature "!pkgbuild"
612     then
613     echo "!pkgbuild detected; skipping stripping of the package '${subpackage}' ..."
614     else
615     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
616     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
617     resume_stamp post-mstripbins_${subpackage}
618     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
619     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
620     resume_stamp post-mstriplibs_${subpackage}
621     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
622     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
623     resume_stamp post-mstripstatic_${subpackage}
624     fi
625    
626     # restore smage environment
627     split_restore_variables
628     done
629     # unset saved variables
630     split_unset_variables
631     else
632     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
633     run_resume post-mstripbins || mstripbins ${BINDIR}
634     resume_stamp post-mstripbins
635     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
636     run_resume post-mstriplibs || mstriplibs ${BINDIR}
637     resume_stamp post-mstriplibs
638     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
639     run_resume post-mstripstatic || mstripstatic ${BINDIR}
640     resume_stamp post-mstripstatic
641     fi
642  fi  fi
643    
644  echo -e "Compressing info-pages ..."  if mqueryfeature "qalint"
 if [ -d ${BUILDDIR}/builded/usr/share/info ]  
645  then  then
646   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   if mqueryfeature "!pkgbuild"
647     then
648     echo "!pkgbuild detected; skipping QA lint checks ..."
649     else
650     if [[ -n ${SPLIT_PACKAGES} ]]
651     then
652     # save smage environment
653     split_save_variables
654     for subpackage in ${SPLIT_PACKAGES}
655     do
656     # honor split_info
657     split_info_${subpackage}
658     if [[ ${PKGTYPE} = virtual ]]
659     then
660     # automatically set !pkgbuild here too
661     msetfeature "!pkgbuild"
662     fi
663    
664     if mqueryfeature "qalint"
665     then
666     if mqueryfeature "!pkgbuild"
667     then
668     echo "!pkgbuild detected; skipping QA lint checks for '${subpackage}' ..."
669     else
670     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks for '${subpackage}' ...${COLDEFAULT}"
671     mqalint ${BINDIR}_${subpackage}
672     fi
673     fi
674    
675     # restore smage environment
676     split_restore_variables
677     done
678     # unset saved variables
679     split_unset_variables
680     else
681     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks ...${COLDEFAULT}"
682     mqalint ${BINDIR}
683     fi
684     fi
685  fi  fi
686    
687  # stripping all bins and libs  if mqueryfeature "!pkgbuild"
688  case ${NOSTRIP} in  then
689   true|TRUE|yes|y)   echo -e "!pkgbuild detected; Package will not be build ..."
690   echo -e "NOSTRIP=true detected; Package will not be stripped ..."  else
691   ;;   # build several subpackages
692   *)   if [[ -n ${SPLIT_PACKAGES} ]]
  echo -e "Stripping binaries ..."  
  mstripbins ${BINDIR}  
  echo -e "Stripping libraries ..."  
  mstriplibs ${BINDIR}  
  ;;  
 esac  
   
 # the new buildpkg command  
 case ${NOPKGBUILD} in  
  true|TRUE|yes|y)  
  echo -e "NOPGKBUILD=true detected; Package will not be build ..."  
  ;;  
  *)  
  # build serveral targets  
  if [ -n "${MAGE_TARGETS}" ]  
693   then   then
694   for target in ${MAGE_TARGETS}   split_save_variables
695     for subpackage in ${SPLIT_PACKAGES}
696   do   do
697   # check if an special target_pkgbuild exists   # get the right variables for the split
698   if typeset -f ${target}_pkgbuild > /dev/null   export PNAME="${subpackage}"
699     split_info_${PNAME}
700     # fix PCATEGORIE -> PCAT
701     if [[ ! -z ${PCATEGORIE} ]]
702     then
703     PCAT="${PCATEGORIE}"
704     unset PCATEGORIE
705     fi
706     if [[ ${PKGTYPE} = virtual ]]
707     then
708     # automatically set !pkgbuild here too
709     msetfeature "!pkgbuild"
710     fi
711    
712     # jump to next one if !pkgbuild is set in split_info
713     if mqueryfeature "!pkgbuild"
714     then
715     # restore smage environment
716     split_restore_variables
717     continue
718     fi
719    
720     # check if an special subpackage_pkgbuild exists
721     if typeset -f ${PNAME}_pkgbuild > /dev/null
722   then   then
723   # run it   # run it
724   ${target}_pkgbuild   run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
725     resume_stamp post-${PNAME}_pkgbuild
726   fi   fi
727   # now create the target package   # now create the target package
728   ${MLIBDIR}/pkgbuild_dir.sh \   run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir.sh \
729   "${PNAME}-${target}-${PVER}-${CHOST%%-*}-${PBUILD}" \   "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
730   ${BINDIR} || die "target: ${target} package-build failed"   "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
731   echo -e "\nPackage ${PNAME}-${target}-${PVER}-${CHOST%%-*}-${PBUILD} successfully builded.\n"   resume_stamp post-pkg_builddir_${PNAME}
732    
733     # build pkg-md5-sum if requested
734     run_resume post-md5sum_${PNAME} || generate_package_md5sum \
735     --pcat "${PCAT}" \
736     --pname "${PNAME}" \
737     --pver "${PVER}" \
738     --pbuild "${PBUILD}" \
739     --parch "${ARCH}"
740     resume_stamp post-md5sum_${PNAME}
741    
742     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
743    
744     # restore smage environment
745     split_restore_variables
746   done   done
747     # unset all saved smage variables
748     split_unset_variables
749    
750   else   else
751   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
752   echo -e "\nPackage ${PKGNAME} successfully builded.\n"   resume_stamp post-pkg_builddir
753    
754     # build pkg-md5-sum if requested
755     run_resume post-md5sum || generate_package_md5sum \
756     --pcat "${PCAT}" \
757     --pname "${PNAME}" \
758     --pver "${PVER}" \
759     --pbuild "${PBUILD}" \
760     --parch "${ARCH}"
761     resume_stamp post-md5sum
762    
763     echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
764   fi   fi
  ;;  
 esac  
765    
766  # for sure   # build src-pkg-tarball if requested
767  unset NOPKGBUILD   if mqueryfeature "srcpkgbuild"
768  unset NOSTRIP   then
769     run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
770     resume_stamp post-srcpkgbuild
771     fi
772    fi
773    
774    # auto regen mage tree if requested
775    regen_mage_tree
776    
777    if mqueryfeature "buildlog"
778    then
779     bzip2 -9f ${SMAGELOGDIR}/${PKGNAME}.log
780    else
781     [[ -f ${SMAGELOGDIR}/${PKGNAME}.log ]] && rm ${SMAGELOGDIR}/${PKGNAME}.log
782    fi
783    
784  xtitleclean  xtitleclean
 #echo -e "\nPackage ${PKGNAME} successfully builded.\n"  

Legend:
Removed from v.192  
changed lines
  Added in v.2805